package com.app.input.color.board.uiactivity;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.ad.tradpluslibrary.TPAdManager;
import com.app.input.color.board.R;
import com.app.input.color.board.databinding.ActivityCategoryBinding;
import com.app.input.color.board.utils.Common;
import com.app.input.color.board.utils.CustomTextView;
import com.app.input.color.board.uifragment.FragmentFavoriteKeyboard;
import com.app.input.color.board.uifragment.FragmentHome;
import com.google.android.material.tabs.TabLayout;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import kotlin.Unit;
import kotlin.jvm.functions.Function0;

public class CategoryActivity extends AppCompatActivity {

    private ActivityCategoryBinding vb;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        vb = ActivityCategoryBinding.inflate(getLayoutInflater());
        Common.INSTANCE.initFullScreen(this,false);
        setContentView(vb.getRoot());
        init();


    }

    private void init() {
       List<Fragment> listFragment = new ArrayList<>();
        listFragment.add(FragmentHome.newInstance());
        listFragment.add(FragmentFavoriteKeyboard.newInstance());

        for (int i = 0; i < listFragment.size(); i++) {
            TabLayout.Tab tab = vb.tabLayout.newTab();

            View inflate = LayoutInflater.from(this).inflate(R.layout.tab_custom_view, null, false);
            ImageView icon = inflate.findViewById(R.id.im_icon);
            CustomTextView textView = inflate.findViewById(R.id.textView);
            if (i == 0) {
                textView.setSelected(true);
                textView.setText(getString(R.string.tab_home));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab_home));
            } else if(i ==1){
                textView.setSelected(false);
                textView.setText(getString(R.string.tab_favorite));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab_favorite));
            }
            tab.setCustomView(inflate);
            vb.tabLayout.addTab(tab);
        }


        vb.viewpager.setUserInputEnabled(false);
        vb.viewpager.setAdapter(new FragmentStateAdapter(this) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                return listFragment.get(position);
            }

            @Override
            public int getItemCount() {
                return listFragment.size();
            }
        });
        bing();
    }


    private void bing() {
        vb.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(true);
                vb.viewpager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(false);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        vb.viewpager.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                Objects.requireNonNull(vb.tabLayout.getTabAt(position)).select();
            }
        });
    }
}